require "import"
import "android.widget.*"
import "android.content.Context"
import "com.androlua.*"
import "android.os.Vibrator"
import "android.os.Handler"

local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(100)

function ejecutarReconocimiento(comando)
  -- Cerrar el diálogo inmediatamente desde el hilo de interfaz
  pcall(function()
    if activity then
      activity.runOnUiThread(function()
        dlgReconocimiento.dismiss()
      end)
    else
      dlgReconocimiento.dismiss()
    end
  end)

  -- Esperar 200 ms para que la interfaz desaparezca visualmente antes de ejecutar
  Handler().postDelayed(function()
    if service.execute(comando) then
      service.asyncSpeak("Ejecutando: " .. comando)
      vibrator.vibrate(100)
    else
      service.asyncSpeak("No se pudo ejecutar el comando.")
    end
  end, 200)
end

local layoutReconocimiento = {
  ScrollView,
  layout_width = "match_parent",
  layout_height = "match_parent",
  {
    LinearLayout,
    orientation = "vertical",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    padding = "16dp",
    {
      TextView,
      text = "Menú de reconocimiento de accesibilidad",
      textSize = "20sp",
      gravity = "center",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      padding = "8dp",
    },
    {
      Button,
      text = "1. Traducir texto enfocado",
      onClick = function()
        ejecutarReconocimiento("Traducir")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
      layout_marginTop = "8dp",
    },
    {
      Button,
      text = "2. Reconocimiento de iconos",
      onClick = function()
        ejecutarReconocimiento("Reconocimiento de iconos")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "3. Descripción de imagen",
      onClick = function()
        ejecutarReconocimiento("Descripción de imagen")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "4. Descripción simple de toda la pantalla",
      onClick = function()
        ejecutarReconocimiento("Descripción simple de toda la pantalla.")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "5. Descripción detallada de imagen",
      onClick = function()
        ejecutarReconocimiento("Descripción detallada de imagen")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "6. Descripción detallada de toda la pantalla",
      onClick = function()
        ejecutarReconocimiento("Descripción detallada de toda la pantalla")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "7. Consulta por voz del objeto enfocado",
      onClick = function()
        ejecutarReconocimiento("Consulta por voz del objeto enfocado")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "8. Consulta por voz en pantalla completa",
      onClick = function()
        ejecutarReconocimiento("Consulta por voz en pantalla completa")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "9. Descripción de video",
      onClick = function()
        ejecutarReconocimiento("Descripción de video")
      end,
      layout_width = "match_parent",
      layout_height = "wrap_content",
    },
    {
      Button,
      text = "Cerrar menú",
      onClick = function()
        dlgReconocimiento.dismiss()
        vibrator.vibrate(100)
        service.asyncSpeak("Menú cerrado.")
      end,
      layout_width = "wrap_content",
      layout_height = "wrap_content",
      layout_gravity = "center",
      layout_marginTop = "12dp",
    },
  }
}

dlgReconocimiento = LuaDialog(service)
dlgReconocimiento.setTitle("Reconocimiento")
dlgReconocimiento.setCancelable(true)
dlgReconocimiento.View = loadlayout(layoutReconocimiento)
dlgReconocimiento.show()